#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
# Variables
# --------------------------------------------------------------

$| = 1;
$P = "dbamon_extents.pl";
$msgfile = "/tmp/db_update_stats_nosap.txt";
$threshold = @ARGV[0];
$option    = @ARGV[1];

#print "$P | Starting\n";

if ($threshold eq "")
{
  print "Error: $P invoked with no passed parameters\n";
}

#
# Subroutines
#

sub error
{
  $msg = @_[0];
  print "\n";
  print "$P | Fatal Error: $msg\n";
  $date = `date`;
  print "$P | Exiting\n";
  exit 1;
}


sub listtables
{
  open(INDB, "echo '\
    set isolation to dirty read;
  select
    a.te_partnum,
    count(*) extents
  from
    systabextents a
  group by
    a.te_partnum
  having
    count(*) >= $threshold
  into temp extbig ;

  select
    \"FLAG\",
    a.te_partnum,
    b.dbsname,
    b.tabname,
    a.extents
  from
    extbig a,
    systabnames   b
  where
    a.te_partnum = b.partnum
    and b.tabname not like \"sys%\"
    and b.dbsbame not like \"BEF%\"
  order by
    3, 4, 2 ;
    ' | dbaccess -e sysmaster 2>&1 |") || die "Error running dbaccess";

  while(<INDB>)
  {
    ##print;
    @words = split;
    $verb    = @words[0];

    if ($verb eq "FLAG")
    {
      $partnum = @words[1];
      $db      = @words[2];
      $table   = @words[3];
      $extents = @words[4];

      push(@t_partnum,$partnum);
      push(@t_db,     $db);
      push(@t_table,  $table);
      push(@t_extents,$extents);
    }

  }
  close(<INDB>);
}


sub gettabname
{
  ##print "table=$table db=$db\n";

  open(IN, "echo '\
    set isolation to dirty read;
    select
      \"FRAGMENT\" flag,
      tabid,
      fragtype,
      dbspace
    from
      sysfragments
    where
      partn = $partnum
    into temp
      frag;

    select
      \"TABLE\",
      tabname
    from
      systables
    where
      tabid =
        (select distinct tabid from frag) ;

    select
      *
    from
      frag;

    ' | dbaccess -e $db 2>/dev/null |") || die "Error running dbaccess";

  while(<IN>)
  {
    ##print;
    @words = split;
    $verb    = @words[0];
    if ($verb eq "FRAGMENT")
    {
      $type    = @words[2];
      $dbspace = @words[3];
      #print "  Fragment Type: $type DBSpace: $dbs \n";
    }
    if ($verb eq "TABLE")
    {
      $table    = @words[1];
      #print "  Actual Table Name: $table \n";
    }
  }
}

# Main

#print "$P | Listing tables with >= $threshold extents\n";
&listtables();

if ($option eq "html")
{
  print "</pre>\n";
  print "<table border=2>\n";
  print "<tr>\n";
  print "<th>DB\n";
  print "<th>Table\n";
  print "<th>Fragment<br>Partnum\n";
  print "<th>Extents\n";
  print "<th>DBSpace<br>(If Fragmented)\n\n";
}

foreach $i (0 .. $#t_table)
{
  $tbl1 = substr($t_table[$i],0,1);
  if ($tbl1 ge "0" && $tbl1 le "9")
  {
    $fragmented = 1;
  }
  else
  {
    $fragmented = 0;
  }

  if ($t_extents[$i] >= 200)
  {
    print "200EXTENTS\n";
  }

  if (!$fragmented)
  {
    if ($option ne "html")
    {
      print "\n";
      print "DB: $t_db[$i]\n";
      print "Table: $t_table[$i]\n";
      print "FragmentPartnum: $t_partnum[$i]\n";
      print "Extents: $t_extents[$i]\n";
    }
    else
    {
      print "<tr>\n";
      print "<td><b>$t_db[$i]\n";
      print "<td><b>$t_table[$i]\n";
      print "<td><b>$t_partnum[$i]\n";
      print "<td><b>$t_extents[$i]\n";
    }
  }
  else
  {
    $db      = $t_db[$i];
    $table   = $t_table[$i];
    $partnum = $t_partnum[$i];
    &gettabname();

    if ($option ne "html")
    {
      print "\n";
      print "DB: $db\n";
      print "Table: $table\n";
      print "FragmentPartnum: $partnum\n";
      print "Extents: $t_extents[$i]\n";
      print "DBSpace: $dbspace\n";
    }
    else
    {
      print "<tr>\n";
      print "<td><b>$db\n";
      print "<td><b>$table\n";
      print "<td><b>$partnum\n";
      print "<td><b>$t_extents[$i]\n";
      print "<td><b>$dbspace\n";
    }
  }
}

if ($option eq "html")
{
  print "</table>\n";
}

exit 0;
