# -----------------------------------------------------------------------------
sub oraSec
# -----------------------------------------------------------------------------
# Changes
#   BB 07Jan04 - Initial
#   BB 11Jan08 - Changed DBA307 from S to C 
#   BB 29Jan08 - New IMPROLE event 
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($asmflag[$thishost])
  {
    &logit("(This check not applicable to +ASM instance)",$thishost);
    return 1;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  if ($g_orasec ne "Y")
  {
    logit("Run_oraSec is not=Y - skipping",$thishost);
    return;
  }

  #---- Look for exceptions

  if ($sec_dbarole[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    print TMPFL6 $sec_dbarole[$thishost];
    close(TMPFL6);
    &event("S",$thishost,"There are $sec_dbarole_cnt[$thishost] Non-System USERs who have been granted the DBA role","DBARole","DBA312",$tmpfl6);
  }

  if ($sec_improle[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    print TMPFL6 $sec_improle[$thishost];
    close(TMPFL6);
    &event("S",$thishost,"There are $sec_improle_cnt[$thishost] Non-System USERs who have been granted the IMP_FULL_DATABASE role","ImpRole","DBA319",$tmpfl6);
  }

  if ($sec_aupriv[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    print TMPFL6 $sec_aupriv[$thishost];
    close(TMPFL6);
    &event("S",$thishost,"There are $sec_aupriv_cnt[$thishost] Non-System USERs who have been granted the ALTER USER priv","AlterUserPriv","DBA318",$tmpfl6);
  }

  if ($sec_userpw[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    #print TMPFL6 $sec_userpw[$thishost];
    print TMPFL6 "(List Not Displayed)\n";
    close(TMPFL6);
    &event("S",$thishost,"There are at least $sec_userpw_cnt[$thishost] Non-System USERs whose userid=password","NS-User=PW","DBA305",$tmpfl6);
  }

  if ($sec_userpwchanged[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    print TMPFL6 $sec_userpwchanged[$thishost];
    close(TMPFL6);
    &event("S",$thishost,"There are $sec_userpwchanged_cnt[$thishost] System USERs whose userid=password - password changed","SysUser=PW-Changed","DBA306",$tmpfl6);
  }

  if ($sec_userpwsys[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    print TMPFL6 $sec_userpwsys[$thishost];
    close(TMPFL6);
    &event("C",$thishost,"There are $sec_userpwsys_cnt[$thishost] System USERs whose userid=password","SysUser=PW","DBA307",$tmpfl6);
  }

  if ($sec_fileperm[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    print TMPFL6 $sec_fileperm[$thishost];
    close(TMPFL6);
    &event("S",$thishost,"There are $sec_fileperm_cnt[$thishost] Oracle file(s) with incorrect permission(s)","Ora-File-Perm","DBA314",$tmpfl6);
  }

  if ($sec_dbagrp_g[$thishost] ne "" || $sec_dbagrp_p[$thishost] ne "")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
    print TMPFL6 $sec_dbagrp_g[$thishost];
    print TMPFL6 $sec_dbagrp_p[$thishost];
    close(TMPFL6);
    $z = $sec_dbagrp_g_cnt[$thishost] + $sec_dbagrp_p_cnt[$thishost];
    &event("S",$thishost,"There are $z UX userids with improper access to the DBA group (SEC-0102,SEC-0103)","DBAGrp","DBA315",$tmpfl6);
  }

  #---- Process dangerous init.ora parms
  if (
       $instance_parms[$thishost]{"REMOTE_OS_AUTHENT"} && 
       $instance_parms[$thishost]{"REMOTE_OS_AUTHENT"} ne "FALSE"
     )
  {
    &event("S",$thishost,"The init.ora parm REMOTE_OS_AUTHENT is ($instance_parms[$thishost]{'REMOTE_OS_AUTHENT'}) - It must be FALSE for security reasons","ParmSec","DBA316");
  }
  if (
       $instance_parms[$thishost]{"REMOTE_OS_ROLES"} && 
       $instance_parms[$thishost]{"REMOTE_OS_ROLES"} ne "FALSE"
     )
  {
    &event("S",$thishost,"The init.ora parm REMOTE_OS_ROLES is ($instance_parms[$thishost]{'REMOTE_OS_ROLES'}) - It must be FALSE for security reasons","ParmSec","DBA316");
  }
  if (
       $instance_parms[$thishost]{"O7_DICTIONARY_ACCESSIBILITY"} && 
       $instance_parms[$thishost]{"O7_DICTIONARY_ACCESSIBILITY"} ne "FALSE"
     )
  {
    &event("S",$thishost,"The init.ora parm O7_DICTIONARY_ACCESSIBILITY is ($instance_parms[$thishost]{'O7_DICTIONARY_ACCESSIBILITY'}) - It must be FALSE for security reasons","ParmSec","DBA316");
  }
}
# -----------------------------------------------------------------------------
1;
